!
subroutine DE19(DS, X0, Y0, H, M, Order, DF, XH, YH, Err)
!     DE33R  :
! ..,  ..   
!   . . . , 1990.
interface
  subroutine DS(X, Y, DY)
  real, intent(in):: X, Y(:)
  real:: DY(:)
  end subroutine DS
end interface
integer, intent(in):: M, Order
real, intent(in):: X0, Y0(M), H
real:: DF(1:M, 0:Order)
real:: XH, YH(M), Err
real, parameter:: ARB=0.001
integer, parameter:: MaxOrder=6
real, parameter:: C(MaxOrder)=(/0.5, 5.0/12.0, 0.375,    &
  251.0/720.0, 95.0/288.0, 19087.0/60480.0/)
real, parameter:: D((MaxOrder*(MaxOrder-1))/2)=    &
  (/-2.,-3.,3.,-4.,5.,-4.,-5.,10.,-10.,5.,-6.,15.,-20.,15.,-6./)
real, allocatable:: X(:), F0(:), F(:), S(:), W(:)
integer:: i, j, k, n, p, Morder
real:: R
!begin
  Morder=Order
  if (Morder>MaxOrder) Morder=MaxOrder
  allocate(X(Morder), F0(M), F(M), S(M), W(M))
  do n=1, Morder
    X(n)=X0+H*float(n)
  end do
  XH=X(Morder)
  call DS(X0, Y0, F0)
  F0(:)=H*F0(:); DF(:,0)=F0(:)
  do n=1, Morder
    YH(:)=Y0(:)
    do k=1, n
      S(:)=YH(:)+DF(:,0)
      do j=1, n-1
        S(:)=S(:)+C(j)*DF(:,j)
      end do
      YH(:)=S(:)
      call DS(X(k), YH, F)
      F(:)=H*F(:)
      do j=0, k-1
        W(:)=DF(:,j); DF(:,j)=F(:); F(:)=F(:)-W(:)
      end do
      DF(:,k)=F(:)
    end do
    DF(:,0)=F0(:)
    do k=1, n-1
      p=(n-1)*(n-2)/2-k
      S(:)=DF(:,k)
      do j=k+1, n
        S(:)=S(:)+D(p+j)*DF(:,j)
      end do
      DF(:,k)=S(:)
    end do
  end do
  Err=0.0
  do i=1, M
    if (abs(Y0(i))>ARB) then; R=abs(Y0(i))
                        else; R=ARB
    end if
    R=abs(F(i))/R
    if (Err<R) Err=R
  end do
  Err=C(Morder)*Err
  deallocate(X, F0, F, S, W)
  return
end subroutine DE19
